<template>
	<q-page padding>
		<q-toolbar>
			<q-toolbar-title v-if="depsLoaded">
				<div v-if="this.$i18n.locale === 'en'">{{ this.department.name_en }}</div>
				<div v-if="this.$i18n.locale === 'nl'">{{ this.department.name_nl }}</div>
			</q-toolbar-title>

			<q-btn :flat="cardLayout" round dense color="primary" icon="map" @click="toggleLayout" />
			<q-btn :flat="!cardLayout" round dense color="primary" icon="view_list" @click="toggleLayout" />
		</q-toolbar>
		<div v-if="depsLoaded">
			<department-cards
				v-if="cardLayout"
				:department="department"
				:facilities="facilities"
				:actions="actions"
				:rooms="rooms"
				@browseTo="browseTo"
			/>
			<department-map
				v-if="!cardLayout"
				:department="department"
				:facilities="facilities"
				:actions="actions"
				:rooms="rooms"
				@browseTo="browseTo"
				@screensize="setLayout"
			/>
		</div>
		<div v-if="soundAlarm">
			<audio loop autoplay>
				<source src="http://localhost:3000/buzz.mp3" type="audio/mp3" />
			</audio>
		</div>
	</q-page>
</template>

<script>
	import departmentCards from "components/departmentCards";
	import departmentMap from "components/departmentMap";
	import fetchFn from "../js/fetch";

	export default {
		// name: 'PageName',
		components: {
			departmentCards,
			departmentMap
		},
		data() {
			return {
				departments: [],
				facilities: [],
				actions: [],
				rooms: [],
				APIURL: "http://localhost:3000",
				depsLoaded: false,
				cardLayout: false,
				departmentDateBeingHandled: false,
				soundAlarm: false
			};
		},
		methods: {
			setLayout() {
				if (this.$q.cookies.has("departmentLayout")) {
					this.cardLayout = this.$q.cookies.get("departmentLayout");
				}
			},
			browseTo(depId) {
				this.$router.push({ name: "department", params: { id: depId } });
			},
			loadData: async function() {
				try {
					this.departments = await fetchFn.getDepartments();
					this.facilities = await fetchFn.getFacilities();
					this.actions = await fetchFn.getActions();
					this.depsLoaded = true;
				} catch (e) {
					this.$alert(
						this.$i18n.t("error.unexpected"),
						this.$i18n.t("error.error"),
						"error"
					);
				}
			},
			toggleLayout() {
				this.cardLayout = !this.cardLayout;
				this.$q.cookies.set("departmentLayout", this.cardLayout, {
					expires: 365,
					path: "/"
				});
			}
		},
		computed: {
			currDepIndex: function() {
				if (!this.depsLoaded) return -1;

				let rawId = decodeURI(this.$route.params.id);
				let id = -1;
				this.departments.forEach(el => {
					if (
						el.id.toString().toLowerCase() ===
						rawId.toString().toLowerCase()
					) {
						id = el.id;
					}

					if (
						el.name_en.toString().toLowerCase() ===
						rawId.toString().toLowerCase()
					) {
						id = el.id;
					}

					if (
						el.name_nl.toString().toLowerCase() ===
						rawId.toString().toLowerCase()
					) {
						id = el.id;
					}
				});
				return id;
			},
			department: function() {
				if (this.currDepIndex === -1 && this.depsLoaded) {
					return this.departments[0];
				}
				return this.departments[this.currDepIndex];
			}
		},
		created() {
			this.setLayout();
			this.loadData();
		},
		watch: {
			currDepIndex() {
				if (this.currDepIndex === -1) {
					this.$router.push({ name: "error404" });
				}
			},
			async department() {
				let rooms = await fetchFn.getRooms();
				let filteredRooms = [];
				rooms.forEach(room => {
					if (this.department.rooms.includes(room.id)) {
						filteredRooms.push(room);
					}
				});
				this.rooms.pop();
				this.rooms = filteredRooms;
			}
		}
	};
</script>
